function advance_player() {
 if (global.player == 1) {
	 global.player = 2
 }else{
	 global.player = 1
}
}

function reset_legal_moves() {
	// loop through each instance of obj_cell, setting legal to false
	for (var i = 0; i < instance_number(obj_cell); i++) {
		instance_find(obj_cell,i).legal = false;
    }
}	
	
function set_legal_bishop_moves() {
			for (var dx = -1; dx <= 1; dx+=2) {
				for (var dy = -1; dy <= 1; dy+=2) {
					// for each direction, go out until we lose line of sight or the edge of the board
					// i.e. until we run ou of legal moves in that direction
					los = true;
					var i = 1
					while (los) {
						var newy = row + i * dy;
						var newx = column + i * dx;
						if (newy >= 0 and newy <= 7) and (newx >= 0 and newx <= 7) and (global.board[newy][newx].piece == "-") {
							global.board[newy][newx].legal = true;
						} else if (newy >= 0 and newy <= 7) and (newx >= 0 and newx <= 7) and (global.board[newy][newx].player != player) {
							global.board[newy][newx].legal = true;
							los = false;
						} else {
							los = false;
						}
						i += 1;
					}
				}
			}
}

function set_legal_rook_moves() {
			for (var dy = -1; dy <= 1; dy+=2) {						
				los = true;
				var i = 1
				while (los) {
					var newy = row + i * dy;
					if (newy >= 0 and newy <= 7) and (global.board[newy][column].piece == "-") {
						global.board[newy][column].legal = true;
					} else if (newy >= 0 and newy <= 7) and (global.board[newy][column].player != player) {
						global.board[newy][column].legal = true;
						los = false;
					} else {
						los = false;
					}
					i += 1;
				}
			}
			for (var dx = -1; dx <= 1; dx+=2) {				
				los = true;
				var i = 1
				while (los) {
					var newx = column + i * dx;
					if (newx >= 0 and newx <= 7) and (global.board[row][newx].piece == "-") {
						global.board[row][newx].legal = true;
					} else if (newx >= 0 and newx <= 7) and (global.board[row][newx].player != player) {
						global.board[row][newx].legal = true;
						los = false;
					} else {
						los = false;
					}
					i += 1;
				}
			}
}	

function set_legal_moves(row,column,piece,player,piece_moves) {
	switch (piece) {
//king		
		case "K":
		case "k":
			for (var i = 1; i <= 1; i += 1) {
				for (var dx = -1; dx <= 1; dx+=2) {
					for (var dy = -1; dy <= 1; dy+=2) {
						var newy = row + i * dy;
						var newx = column + i * dx;
						if (newy >= 0 and newy <= 7) and (newx >= 0 and newx <= 7) and (global.board[newy][newx].player != player) {
							global.board[newy][newx].legal = true;
						}
					}
				}
			}
			for (var i = 1; i <= 1; i += 1) {
				for (var dy = -1; dy <= 1; dy+=2) {
					var newy = row + i * dy;
					if (newy >= 0 and newy <= 7) and (global.board[newy][column].player != player){
						global.board[newy][column].legal = true;
					}
				}
			}
			for (var i = 1; i <= 1; i += 1) {
				for (var dx = -1; dx <= 1; dx+=2) {
					var newx = column + i * dx;
					if (newx >= 0 and newx <= 7) and (global.board[row][newx].player != player) {
						global.board[row][newx].legal = true;
					}
				}
			}
			if (piece_moves == 0) {
				set_castling(row,column)
			}
			break;
//knight		
		case "N":
		case "n":
			if (row < 6) and (column > 0) and (global.board[row+2][column-1].player != player) {
				global.board[row+2][column-1].legal = true;
			}	
			if (row < 6) and (column < 7) and (global.board[row+2][column+1].player != player) {
				global.board[row+2][column+1].legal = true;
			}
			if (row > 1) and (column > 0) and (global.board[row-2][column-1].player != player) {
				global.board[row-2][column-1].legal = true;
			}
			if (row > 1) and (column < 7) and (global.board[row-2][column+1].player != player) {
				global.board[row-2][column+1].legal = true;
			}
			if (column < 6 ) and (row > 0) and (global.board[row-1][column+2].player != player) {
				global.board[row-1][column+2].legal = true;
			}
			if (column < 6) and (row < 7) and (global.board[row+1][column+2].player != player) {
				global.board[row+1][column+2].legal = true;
			}
			if (column > 1) and (row > 0) and (global.board[row-1][column-2].player != player) {
				global.board[row-1][column-2].legal = true;
			}
			if (column > 1) and (row < 7) and (global.board[row+1][column-2].player != player) {
				global.board[row+1][column-2].legal = true;
			}
			break;
//queen
		case "Q":
		case "q":
			set_legal_rook_moves()
			set_legal_bishop_moves()
			break;
//Bishop
		case "B":
		case "b":
			set_legal_bishop_moves()
			break;
//rook
		case"R":
		case"r":
			set_legal_rook_moves()
			break;
//pawn
		case"P":
			if (row == 1) and (global.board[row + 2][column].player == 0) and (global.board[row + 1][column].player == 0) {
				global.board[row + 2][column].legal = true;
			}
			if (row < 7) and (global.board[row + 1][column].player == 0) {
				global.board[row + 1][column].legal = true;
			}
			if (row < 7) and (column < 7) and (global.board[row + 1][column + 1].player == 1) {
				global.board[row + 1][column + 1].legal = true;
			}
			if (row < 7) and (column > 0) and (global.board[row + 1][column - 1].player == 1) {
				global.board[row + 1][column - 1].legal = true;
			}
			break;

		case"p":
			if (row == 6) and (global.board[row - 2][column].player == 0) and (global.board[row - 1][column].player == 0) {
				global.board[row - 2][column].legal = true;
			}
			if (row > 0) and (global.board[row - 1][column].player == 0) {
				global.board[row - 1][column].legal = true;
			}
			if (row > 0) and (column < 7) and (global.board[row - 1][column + 1].player == 2) {
				global.board[row - 1][column + 1].legal = true;
			}
			if (row > 0) and (column > 0) and (global.board[row - 1][column - 1].player == 2) {
				global.board[row - 1][column - 1].legal = true;
			}
			break;
	}
}

function set_castling(row,column) {
	
	// assume castling is possible, until it isn't
	// to start with, we'll just check to the right
	castling_right = true;
	
	// check that we have line of sight to the rook (right)

	if (global.board[row][column + 1].piece != "-" or  global.board[row][column + 2].piece != "-") {
			castling_right = false;
	}

	if (castling_right) and (global.board[row][column].piece_moves == 0) and (global.board[row][7].piece_moves == 0) {
		global.board[row][column + 2].legal = true;
	}
			
	// check that the piece isn't moving through or into check
	// TO DO stretch goal
		
	// repeat for left
	castling_left = true;
	
	// check that we have line of sight to the rook (right)

	if (global.board[row][column - 1].piece != "-" or  global.board[row][column - 2].piece != "-" or global.board[row][column - 3].piece != "-") {
			castling_left = false;
	}

	if (castling_left) and (global.board[row][column].piece_moves == 0) and (global.board[row][0].piece_moves == 0) {
		global.board[row][column - 2].legal = true;
	}
			
	
	
}
